# Notes to a Software Team Leader, by Roy Osherove

- You end up in charge of a team. They look to you for technical guidance. Your job is as much about creating and sharing a consistent vision as it is about delivering great software.

- What is the job of the supervisor at a car repair shop? The good ones feel they get paid to have a great workforce that's always ready and able to service the cars in a way that makes the customers happy.

- Your manager might say that `you get paid to ship software`. In turn, for you, that means that you need to do everything in your power to make your team the best at delivering that software, dealing with any needs that come up, and being able to solve problems in a quick way, without having any bottlenecks.
  `Translated`: You are being paid to make tough calls and judgments to the best of your knowledge and ability so you can achieve this. You are being paid to get your team to a level where they do things professionally. You are being paid to keep taking the team to the next level of performance and professionalism, because that's what will allow them to deliver the software that needs to be written.

- If management tells you "thanks, but no thanks. No need to grow our teams, just write the damn things" -> Find another place where management does want people to make the best of themselves. -> You don't have to leave -> show success patterns to management when you have some numbers in your hands, if nothing changes -> pack your things and go.

# Survival mode

- Play to the team strengthens. If someone is an expert, let they do that until you get out of survival mode.

- If someone is a bad influence on the team, for example, always pessimistic, your responsibility to the team is to remove that problem.

- Having someone question decisions in the middle of survival mode in front of the whole team can be a show stopper. Too much doubt, especially in difficult times, can bring a whole team down, in my experience.

- There is always the "no downers" rule, in which you don't allow immature behaviour within the team. Phrases like: "I knew it would never work" count as downers in this book.

- During transformation you will likely need to spend more time with the team. At least 50 percent of your time should be spent either in the team room or talking or working with one of the developers.

- A stuck team cannot put out fires and cannot move onto learning mode because they haven't made enough time for it.

- There has to be a time investment first. And it has to be you because you are the one who leads the team.

- What if you are not a technical leader? It's still vastly important that you be there, to see any team problems that come up and how your technical leader is solving them. You should be there feeling the pain while getting out of survival mode.

- He learned how to look at and play the game differently, and to do that, he had to let go of his "sure footing" and unlearn things he had learned. To get to the next stage and to become much better than you are, you have to let go of the things you already know. You have to ler go of the safety of the current position you're in, so that you climb to the next level. You're about to take a risk, do something you've never done before, and change circumstances that seem almost unchangeable.

- Eventually, you realize that in life you always have to get uncomfortable before you learn new skills, and that is just the phase of learning.

- Do not fear confrontation. Make sure you can live with whatever is being decided, if you can't, you should say so.

- You have to be able to achieve a real change, not pretend change. If you need 100 percent more time and you get 20 percent more time, that's something you cannot live with. You have to say so.

- You have to be able to say "This is the best way I know how to run this team. Let me do my job". You should be able t say "This is how I work, if you know someone who can do this job better and get this team to be better, you should hire them".

- Don't stay where you're not appreciated and where you cannot change things. Don't stay in a place that makes you feel miserable.

- Commit to a place where you can live with how things are going or change how things are going so you can live with them.

- Being a leader can, at the beginning, feel quite lonely, but it can also feel amazingly fulfiling to drive for a real change you believe in.

- Your focus is to get the team out of survival mode, to make time for your team to learn new things, to get the team to be better. You might need to be a bit more command and control in your actions.

- One of the common ways to recognize such lack of skill to self-organise is that the team keeps expecting the team leader to solve all of their problems for them. Letting them go alone into the jungle will likely get them frustrated and stuck trying to get through a maze of issues they're not used to dealing with.

- Find out your current risks. `Future memory`: Imagine it is six months from now, and our project has failed completely. Why did it fail?

- Learn how to say no by saying yes. Move features down in order to build the new most wanted feature.

- Understand the notion of broken windows.

# Elastic Leadership

```
- The reasonable man adapts himself to the world: the unreasonable one persists in trying to adapt the world to himself. Therefore all progress depends on the unreasonable man.
- George Bernand Shaw, Man and Superman
```

- A team leader should provide to their team everything the team needs and then get out of their way.

- `Command and control` This approach won't work if your team already knows what they're doing or if they expect to learn new things and be challenged to become better.

- `Coach` This approach won't work if you and your team don't have enough free time to actually practice and do any learning. So if you're busy putting out fires all day, and you're already behind schedule anyway, you won't have time to also learn or try new things like refactoring or test driven development.

- `Facilitator` This whole approach won't work if the team does not have sufficient skills to solve their own problems (such as slow machines, talking to customers, and so on).

- For integrity to exists, you have to insist that people commit only to things under their own control.

- A team leader grows the people in their team.

- People don't quit their jobs. They quit their managers.

- By solving your team's problems, you're being their bottleneck, and they'll find themselves unable to manage without you.

- Homework is actually something you do at work, or sometimes at home if you'd like. It doesn't relate to the day-to-day actual task, and it's not something that's officially designated as part of your job. It's usually a task that you incorporate into your actual work, such as "try to say yes at least three times a day" or "be the last one to speak in every conversation".

- Get the team of the survival phase by creating slack time.

- Your main goal as a leader, in order to achieve your overall role of growing people, is to grow the team to be self-organised by teaching and challenging them to solve their own problems.

- You can tell you are `self-organising`phase if: You can leave work a few days without being afraid to turn off your cell phone and laptop. If you can do that, come back, and things are going well, your team is in the quite unique position of solving their own problems without needing you to help them through.

# Learning to learn

```
You have learnt something. That always feels at first as if you have lost something.
- George Bernand Shaw, Major Barbara.
```

- The true power of learning is to realize this simple fact: ravines eventually end and you are left with new knowledge.

- You might be facing a ravine if:

  - You're scared to take this step because you might lose face, dignity, money, or friends.
  - You feel like this isn't something that's meant for you.
  - It will change you, how you perceive your world or your work or people you encounter.
  - It will teach you new skills.

- Instead of "What are you going to do about it?" try -> What do you think you should do about it? What can you do about it? How do you intend to solve it?

- Ask your team that as soon as someone realizes they will not make their commitment, they raise a flag as quickly as possible to the entire team or yo you (if it was a personal commitment). The quicker they raise the flag, the bigger the chances that the team, as a team, can help out and increase the odds of that person's living up to their commitment.

# Striving towards a Team Leader Manifesto

- We accept that the team's needs from us change continuously based on their skills for handling the current reality of work, so we embrace a continuously changing leadership style over a one-style-fits-all leadership approach.
- We believe in challenging ourselves and our teams to always get better, so:
  - We create slack time for the team to learn and be challenged.
  - We embrace taking risks for our team over staying safe.
  - We embrace fear and discomfort while learning new skills over keeping people within their comfort zone.
  - We embrace experimentation as a constant practice over maintaining the status quo:
    - With people.
    - With tools.
    - With processes.
    - With the environment.
  - We believe our core practice is leading people, not wielding machines, so:
    - We embrace spending more time with our team than in meetings.
    - We embrace treating software problems as people problems.
    - We learn people skills and communication techniques.
