# The role of data in green software engineering, by Simon Muller.

## Communities

- climateaction.tech
- greensoftware.foundation
- climatechange.ai
- lfca.earth
- climatedesigners.org

## Books

- Building sustainable digital products 
- Designing for sustainability
- Sustainable web design
- The carbon footprint of everything

## Talk

- Dark data is that that no front end will ever see. 70 to 90% falls in this category.
  - For example, backups take a lot of space. As an strategy, maybe just retain daily data for a month
  - then spread the interval, and not full backups, just increments.
- When we looked at one company, we found that 30% of the entire data were just duplicates
  - `Data is gold but too much will weight you down`
- Think if you need all this data, or if you can get enough with 20% following the Pareto Principle.
- Think about the sense of value that you need
- No one like processes, but learning is fine.

## Checklist for Watxx projects

1. Sustainability in Tech
   2. Definition
   3. Planning
      4. Life-cycle assesment (LCA) for digital solutions
      5. Product specification for the Sustainability Assessment
      6. Overall assessment and metrics
         7. Direct metrics: Sustainability meassurement
         8. Proxy metrics
      9. Infrastructure
         10. Architecture
         11. Implementation
         12. Interfaces
         13. Measurement
             14. Customer devices. Do you need your customers to really upgrade their phones?
             15. Sustainability report
      16. Backend
          17. Architeture
              18. Language
              19. Databases
              20. Frameworks
          21. Implementation
              22. Database
              23. Storage
              24. Backups
              25. Algorithms
              26. Dependency
          27. Interfaces
              28. Product team / tester is your friend
              29. FE is your friend
      30. ...