# GOTO 2018 - Talking with Tech Leads by Patrick Kua

[Link to talk](https://www.youtube.com/watch?v=iLS6NXMXtLI)

# Archetypical Story

- The tech lead is not a promotion, it's a role change.
- Being torn between what you know: delivering vs leading a team
- In a career ladder, you would have expectations behaviour and impact for a given position. Agree what is the expectation in your role and level.
  - A career ladder can help guide a conversation, it's not a complete checklist, it reduces system bias.
- In the Valley they talk about two tracks: `Individual contributor` vs `Management`.
  - For Patrick it's a three track: `Technical Leader` / `Individual Contributor` and `Management`.
    - Think where do you spend the mayority of your time.
      - `Individual`: 70-80% Executing.
      - `Management`: 70-80% Managing the system. Ex: When to split a team? Planning? Budgeting? Organising?
      - `Tech Lead`: Aligning team. Ex: How do we split monolith? Technical Risk management: encouraging refactor, knowledge sharing, break big problems into smaller problems, tech vision, tech debt management, growing technical knowledge
- What got you here, won't get you there.

# What is a Tech Lead?

- A tech lead is a software engineer, responsible for leading a development team, and responsible for the quality of its technical deliverables.
- You need Architectural Skills, Developer Skills and Leadership Skills.
- The role requires effective leadership.
- At least 30% of the time with the team coding (reading, writing...)
- Steering in the right direction would make the code base look like it was written from the same person.
- Skills to invest in:
  - Empathy
  - Self-awareness
  - Motivation
  - Conflict resolutions
- Benefit from many resources on leadership. Be sure to practice.

# Books recommended

- Getting to Yes
- Power and positive leadership
- Emotional intelligence 2.0
- The coachin habit: Say less, ask more
- Thanks feedback
- Crucial conversations
- Presentation patterns
- Highly effective people
- The busy manager's guide to delegation
- Great motivation secrets of great leaders
- Non violent communication
- The psychology influence of persuasion
- Strenghtsfinder 2.0

#

"Reading is still the main way that I both learn new things and test my understanding" - Bill Gates (2016)

# Surprises & Struggles

- Feeling alone.
- Uncertainty.
- People are puzzling: Unique, different strengths, archetypes not stereotypes. Try not to project your personal experience on somebody else just because it looks like something you know.
- Build a support structure.

# Tips to become a great tech lead

- Tell or delegate
  - Tell -> Sell -> Participate -> Delegate
- Tap into diverse approaches

`Eisenhower Matrix`:

- Important and Urgent: Do
- Important less Urgent: Decide
- Less important & Urgent: Delegate
- Less important & Less Urgent: Delete

- Move from Maker to Multiplayer mode.
